TradeView = Subview:extend {
   drawParent = true, --default?
   onNew = function (self)
              -- create all the interface bits from the planet
              -- and add them to the view

              local boxL = the.app.width / 2 - 200
              local boxT = the.app.height / 2 - 200
              local boxR = boxL + 400

              local lh = 17 -- line height

              self:add(Fill:new{
                          fill = {255,255,255},
                          x = boxL - 1,
                          y = boxT - 1,
                          width = 402,
                          height = 402,
                       })

              self:add(Fill:new{
                          fill = {0,0,0},
                          x = boxL,
                          y = boxT,
                          width = 400,
                          height = 400,
                       })

              for i, good in ipairs(self.planet.goods) do
                 local t = Text:new{
                    text = good[1],
                    x = boxL + 10,
                    y = boxT + 10 + (i-1) * lh,
                    width = 380
                 }

                 self:add(t)

                 t = Text:new{
                    text = good[2],
                    x = boxL + 10,
                    y = boxT + 10 + (i-1) * lh,
                    width = 300,
                    align = 'right'
                 }
                 self:add(t)

                 local b = Button:new{
                    x = boxR - 80,
                    y = boxT + 10 + (i-1) * lh - 1,
                    label = Text:new{ text = 'BUY', x = 1 },
                 }
                 local tw, th = b.label:getSize()
                 b.background = Fill:new{
                    fill = {100,100,100},
                    width = tw + 3,
                    height = th
                 }
                 self:add(b)

                 b = Button:new{
                    x = boxR - 40,
                    y = boxT + 10 + (i-1) * lh - 1,
                    label = Text:new{ text = 'SELL', x = 1 },
                 }
                 local tw, th = b.label:getSize()
                 b.background = Fill:new{
                    fill = {100,100,100},
                    width = tw + 3,
                    height = th
                 }
                 self:add(b)
              end

              local b = Button:new{
                 x = boxL, y = boxT,
                 label = Text:new{ text = 'Close', x = 3, y = 2 },
                 onMouseDown = function()
                                  self:close()
                               end
              }

              local tw, th = b.label:getSize()
              b.background = Fill:new{
                 fill = {100,100,100},
                 width = tw + 7,
                 height = th + 4
              }
              b.x = boxR - b.background.width - 10
              b.y = boxT + 400 - b.background.height - 10

              self:add(b)

              -- give the buttons a cycle to get out of the T/L corner
              self:update(0)
           end,
   activate = function (self)
                 the.cursor.visible = false
                 love.mouse.setVisible(true)
                 love.mouse.setGrab(false)

                 Subview.activate(self)
              end,
   close = function (self)
              the.cursor.visible = true
              love.mouse.setVisible(false)
              love.mouse.setGrab(true)

              self:deactivate()
           end,
   onUpdate = function (self)
                 if the.keys:justPressed('escape') then
                    self:close()
                 end
              end
}